@ Part of the Tremolo Ogg Vorbis codec.
@
@ Copyright (C) Robin Watts.
@
@ See enclosed ReadMe/First for licensineg details.

	.text

	.global	decode_packed_entry_number

decode_packed_entry_number:
	@ r0 = codebook       *book
	@ r1 = oggpack_buffer *b
	STMFD	r13!,{r4-r10,r14}

	LDMIA	r1,{r4,r5,r6,r7}	@ r4 = p
					@ r5 = bits
					@ r6 = p_end
					@ r7 = bits_end
	SUB	r6,r6,r4
	SUB	r7,r5,r7
	ADD	r6,r7,r6,LSL#3		@ r6 = bits left

	LDMIA	r4,{r7,r10}
	RSB	r9,r5,#32
	MOV	r7,r7,LSR r9
	ORR	r7,r7,r10,LSL r5

	@ r0 = book
	@ r1 = b
	@ r4 = p
	@ r5 = bits
	@ r6 = bits left in stream
	@ r7 = Next 32 bits from stream
	LDMIA	r0,{r2,r3,r8,r9,r10,r14}@ r2 = book->used_entries
					@ r3 = book->dec_codelengths
					@ r8 = book->dec_firsttable
					@ r9 = book->dec_firsttablen
					@ r10= read = book->dec_maxlength
					@ r14= book->codelist
	MVN	r12,#0
	CMP	r9,r6
	BGT	overrun1
	BIC	r9,r7,r12,LSL r9
	LDR	r9,[r8,r9,LSL#2]	@ r9 = entry = dec_first_table[lok]
	@ Stall
	CMP	r9,#0			@ if (entry >= 0)
	BGE	quickexit		@   goto quickexit
	MOV	r0,r9,LSR#15		@ r0 = (entry>>15)
	BIC	r0,r0,#0xFF0000		@ r0 = lo
	AND	r9,r9,r12,LSR#17	@ r9 = (entry & 0x7FFF)
	SUB	r2,r2,r9		@ r2 = hi = book->used_entries-r9
overrun1_ret:
	@ r0 = lo
	@ r1 = b
	@ r2 = hi
	@ r3 = book->dec_codelengths
	@ r4 = p
	@ r5 = bits
	@ r6 = bits left in stream
	@ r7 = Next 32 bits in stream
	@ r10= read
	@ r14= book->codelist

	@ Now read as many bits as we can, up to read */
	CMP	r10,r6
	BGE	overrun2
overrun2_ret:
	BIC	r9,r7,r12,LSL r10	@ r9 = lok = oggpack_look(b, read)
	@ r0 = lo
	@ r1 = b
	@ r2 = hi
	@ r3 = book->dec_codelengths
	@ r4 = p
	@ r5 = bits
	@ r6 = bits left in stream
	@ r7 = Next 32 bits in stream
	@ r9 = lok
	@ r10= read
	@ r14= book->codelist
	@ now bitreverse r9 = 12345678
	MOV	r8,r9,LSR#16		@ r8 = 56780000
	ORR	r9,r8,r9,LSL#16		@ r9 = 56781234
	MOV	r12,#0xFF		@ r12= 000000FF
	EOR	r12,r12,r12,LSL#16	@ r12= 00FF00FF
	AND	r8,r12,r9,LSR#8		@ r8 = 00560012
	AND	r9,r12,r9		@ r9 = 00780034
	ORR	r9,r8,r9,LSL#8		@ r9 = 78563412
	EOR	r12,r12,r12,LSL#4	@ r12= 0F0F0F0F
	AND	r8,r12,r9,LSR#4		@ r8 = 07050301
	AND	r9,r12,r9		@ r9 = 08060402
	ORR	r9,r8,r9,LSL#4		@ r9 = 87564321
	EOR	r12,r12,r12,LSL#2	@ r12= 33333333
	AND	r8,r12,r9,LSR#2
	AND	r9,r12,r9
	ORR	r9,r8,r9,LSL#2
	EOR	r12,r12,r12,LSL#1	@ r12= 55555555
	AND	r8,r12,r9,LSR#1
	AND	r9,r12,r9
	ORR	r9,r8,r9,LSL#1		@ r9 = lok = bitreverse(lok)

	SUB	r8,r2,r0		@ r8 = hi-lo
	MOVS	r8,r8,ASR#1		@ r8 = p = (hi-lo)>>1
	@ We use the equivalence that (hi-lo)>1 iff ((hi-lo)>>1) > 0
	BLE	over_lp			@ while (((hi-lo)>>1) > 0) {
lp:
	ADD	r12,r14,r0,LSL#2	@   r12 = codelist+lo
	LDR	r12,[r12,r8,LSL#2]	@   r12 = book->codelist[lo+p]
	@ Stall
	CMP	r12,r9			@   if (r12 > lok)
	SUBHI	r2,r2,r8		@     hi -= p@
	ADDLS	r0,r0,r8		@   else lo += p@
	SUB	r8,r2,r0		@   r8 = (hi-lo)
	MOVS	r8,r8,ASR#1		@   r8 = (hi-lo)>>1
	BGT	lp			@ }
over_lp:
	LDRB	r3,[r3,r0]		@ r3 = codelengths[lo]
	@ Stall
	CMP	r3,r10
	MOVLE	r10,r3			@ r10 = number of bits to advance
	MVNGT	r0,#0			@ r8  = return value
exit:
	SUBS	r5,r5,r10
	ADDLE	r5,r5,#32
	ADDLE	r4,r4,#4
	STMIA	r1,{r4,r5}

	LDMFD	r13!,{r4-r10,PC}

overrun1:
	MOV	r0,#0
	B	overrun1_ret

overrun2:
	@ read > number of bits in the stream
	MOVS	r10,r6		@ r10 = read = number of bits left
	BGT	overrun2_ret	@ if (read >= 1) go back
	MOV	r10,#0
	MVN	r0,#0
	B	exit

quickexit:
	@ r0 = lo
	@ r1 = b
	@ r2 = hi
	@ r3 = book->dec_codelengths
	@ r4 = p
	@ r5 = bits
	@ r6 = bits left in stream
	@ r7 = Next 32 bits in stream
	@ r9 = entry
	@ r10= read
	@ r14= book->codelist
	SUB	r0,r9,#1
	LDRB	r10,[r3,r0]	@ r10 = codelengths[entry-1]
	B	exit
